
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>阿里巴巴Java 开发手册编程规约之OOP规约 / 憋错料</title>

    <meta name="description" content="阿里巴巴Java 开发手册编程规约之OOP规约 1. [强制]避免通过一个类的对象引用访问此类的静态变量或静态方法,无谓增加编译器解析成本,直接用类名来访问即可.2. [强制]所有的覆写方法,必须加@Override 注解.说明: getObject()与 get0bject()的问题.一个是字母的 O,一个是数字的 0,加@Override可以准确判断是否覆盖成功.另外,如果在抽象类中对方法签名进行修改,其实现类会马上编译报错.3. [强制] 相同参数类型,相同业务含义,才可以使用 Java 的可变参数,避免使用 Object.说明: 可变">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">阿里巴巴Java 开发手册编程规约之OOP规约</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>1. 【强制】避免通过一个类的对象引用访问此类的静态变量或静态方法，无谓增加编译器解析成本，直接用类名来访问即可。<br />2. 【强制】所有的覆写方法，必须加@Override 注解。<br />说明： getObject()与 get0bject()的问题。一个是字母的 O，一个是数字的 0，加@Override可以准确判断是否覆盖成功。另外，如果在抽象类中对方法签名进行修改，其实现类会马上编译报错。<br />3. 【强制】 相同参数类型，相同业务含义，才可以使用 Java 的可变参数，避免使用 Object。<br />说明： 可变参数必须放置在参数列表的最后。 （提倡同学们尽量不用可变参数编程）<br />正例： public User getUsers(String type, Integer... ids) {...}<br />4. 【强制】外部正在调用或者二方库依赖的接口，不允许修改方法签名，避免对接口调用方产生影响。接口过时必须加@Deprecated 注解，并清晰地说明采用的新接口或者新服务是什么。<br />5. 【强制】不能使用过时的类或方法。<br />说明： java.net.URLDecoder 中的方法 decode(String encodeStr) 这个方法已经过时，应该使用双参数 decode(String source, String encode)。接口提供方既然明确是过时接口，那么有义务同时提供新的接口； 作为调用方来说，有义务去考证过时方法的新实现是什么。<br />6. 【强制】 Object 的 equals 方法容易抛空指针异常，应使用常量或确定有值的对象来调用equals。<br />正例： "test".equals(object);<br />反例： object.equals("test");<br />说明： 推荐使用 java.util.Objects#equals （JDK7 引入的工具类）<br />7. 【强制】所有的相同类型的包装类对象之间值的比较，全部使用 equals 方法比较。<br />说明： 对于 Integer var = ? 在-128 至 127 范围内的赋值， Integer 对象是在IntegerCache.cache 产生，会复用已有对象，这个区间内的 Integer 值可以直接使用==进行<br />判断，但是这个区间之外的所有数据，都会在堆上产生，并不会复用已有对象，这是一个大坑，推荐使用 equals 方法进行判断。<br />8. 关于基本数据类型与包装数据类型的使用标准如下：<br />1）【强制】 所有的 POJO 类属性必须使用包装数据类型。<br />2）【强制】 RPC 方法的返回值和参数必须使用包装数据类型。<br />3）【推荐】 所有的局部变量使用基本数据类型。<br />说明： POJO 类属性没有初值是提醒使用者在需要使用时，必须自己显式地进行赋值，任何NPE 问题，或者入库检查，都由使用者来保证。<br />正例： 数据库的查询结果(po)可能是 null，因为自动拆箱，用基本数据类型接收有 NPE 风险。</p>
<p>反例： 比如显示成交总额涨跌情况，即正负 x%， x 为基本数据类型，调用的 RPC 服务，调用不成功时， 返回的是默认值，页面显示： 0%，这是不合理的，应该显示成中划线-。所以包装数据类型的 null 值，能够表示额外的信息，如：远程调用失败，异常退出。</p>
<p>9. 【强制】定义 DO/DTO/VO 等 POJO 类时，不要设定任何属性默认值。<br />反例： POJO 类的 gmtCreate 默认值为 new Date();但是这个属性在数据提取时并没有置入具体值，在更新其它字段时又附带更新了此字段，导致创建时间被修改成当前时间。<br />10. 【强制】序列化类新增属性时，请不要修改 serialVersionUID 字段，避免反序列失败； 如果完全不兼容升级，避免反序列化混乱，那么请修改 serialVersionUID 值。<br />说明： 注意 serialVersionUID 不一致会抛出序列化运行时异常。<br />11. 【强制】构造方法里面禁止加入任何业务逻辑，如果有初始化逻辑，请放在 init 方法中。<br />12. 【强制】 POJO 类必须写 toString 方法。使用 IDE 的中工具： source&gt; generate toString时，如果继承了另一个 POJO 类，注意在前面加一下 super.toString。<br />说明： 在方法执行抛出异常时，可以直接调用 POJO 的 toString()方法打印其属性值，便于排查问题。<br />13. 【推荐】使用索引访问用 String 的 split 方法得到的数组时，需做最后一个分隔符后有无内容的检查，否则会有抛 IndexOutOfBoundsException 的风险。<br />说明：</p>
<pre>String str = "a,b,c,,";
String[] ary = str.split(",");
//预期大于 3，结果是 3
System.out.println(ary.length);  </pre>
<p>14. 【推荐】当一个类有多个构造方法，或者多个同名方法，这些方法应该按顺序放置在一起，便于阅读。<br />15. 【推荐】 类内方法定义顺序依次是：公有方法或保护方法 &gt; 私有方法 &gt; getter/setter<br />方法。<br />说明： 公有方法是类的调用者和维护者最关心的方法，首屏展示最好； 保护方法虽然只是子类关心，也可能是“模板设计模式”下的核心方法； 而私有方法外部一般不需要特别关心，是一个黑盒实现； 因为方法信息价值较低，所有 Service 和 DAO 的 getter/setter 方法放在类体最后。</p>
<p>16. 【推荐】 setter 方法中，参数名称与类成员变量名称一致， this.成员名 = 参数名。在getter/setter 方法中， 不要增加业务逻辑，增加排查问题的难度。</p>
<p>反例：</p>
<pre>public Integer getData() {
    if (true) {
        return this.data + 100;
    } else {
        return this.data - 100;
    }
}</pre>
<p>17. 【推荐】循环体内，字符串的连接方式，使用 <strong>StringBuilder </strong>的 append 方法进行扩展。<br />说明： 反编译出的字节码文件显示每次循环都会 new 出一个 <strong>StringBuilder</strong> 对象，然后进行append 操作，最后通过 toString 方法返回 String 对象，造成内存资源浪费。<br />反例</p>
<pre>String str = "start";
for (int i = 0; i &lt; 100; i++) {
    str = str + "hello";
}</pre>
<p>18. 【推荐】 final 可以声明类、成员变量、方法、以及本地变量，下列情况使用 final 关键字：<br />1） 不允许被继承的类，如： String 类。<br />2） 不允许修改引用的域对象，如： POJO 类的域变量。<br />3） 不允许被重写的方法，如： POJO 类的 setter 方法。<br />4） 不允许运行过程中重新赋值的局部变量。<br />5） 避免上下文重复使用一个变量，使用 final 描述可以强制重新定义一个变量，方便更好地进行重构。<br />19. 【推荐】慎用 Object 的 clone 方法来拷贝对象。<br />说明： 对象的 clone 方法默认是浅拷贝，若想实现深拷贝需要重写 clone 方法实现属性对象的拷贝。<br />20. 【推荐】类成员与方法访问控制从严：<br />1） 如果不允许外部直接通过 new 来创建对象，那么构造方法必须是 private。<br />2） 工具类不允许有 public 或 default 构造方法。<br />3） 类非 static 成员变量并且与子类共享，必须是 protected。<br />4） 类非 static 成员变量并且仅在本类使用，必须是 private。<br />5） 类 static 成员变量如果仅在本类使用，必须是 private。<br />6） 若是 static 成员变量，必须考虑是否为 final。<br />7） 类成员方法只供类内部调用，必须是 private。<br />8） 类成员方法只对继承类公开，那么限制为 protected。<br />说明： 任何类、方法、参数、变量，严控访问范围。过于宽泛的访问范围，不利于模块解耦。<br />思考：如果是一个 private 的方法，想删除就删除，可是一个 public 的 service 方法，或者一个 public 的成员变量，删除一下，不得手心冒点汗吗？变量像自己的小孩，尽量在自己的视线内，变量作用域太大，如果无限制的到处跑，那么你会担心的。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-06 10:11:59 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/net/" title="net">net</a>, <a href="https://www.biecuoliao.com/tag/ati/" title="ati">ati</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%9c%e7%94%a8%e5%9f%9f/" title="作用域">作用域</a>, <a href="https://www.biecuoliao.com/tag/uid/" title="uid">uid</a>, <a href="https://www.biecuoliao.com/tag/decode/" title="decode">decode</a>, <a href="https://www.biecuoliao.com/tag/%e6%a8%a1%e6%9d%bf/" title="模板">模板</a>, <a href="https://www.biecuoliao.com/tag/rpc/" title="rpc">rpc</a>, <a href="https://www.biecuoliao.com/tag/%e8%bf%90%e8%a1%8c%e6%97%b6%e5%bc%82%e5%b8%b8/" title="运行时异常">运行时异常</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>阿里巴巴Java 开发手册编程规约之OOP规约的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Q7qR20.html" rel="bookmark">阿里巴巴Java 开发手册编程规约之异常日志</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(一)异常处理1. [强制]Java 类库中定义的一类 RuntimeException 可以通过预先检查进行规避,而不应该通过 catch 来处理,比如: IndexOutOfBoundsException, NullPointerException 等等.说明: 无法通过预检查的异常除外,如在解析一个外部传来的字符串形式数字时,通过 catchNumberFormatException 来实现.正例: if (obj != null) {...}反例: try { obj.method()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVgOXx0.html" rel="bookmark">阿里巴巴Java 开发手册编程规约之工程结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(一)应用分层1. [推荐]图中默认上层依赖于下层,箭头关系表示可直接依赖,如:开放接口层可以依赖于Web 层,也可以直接依赖于 Service 层,依此类推: 开放接口层:可直接封装 Service 方法暴露成 RPC 接口: 通过 Web 封装成 http 接口: 进行网关安全控制. 流量控制等.终端显示层:各个端的模板渲染并执行显示的层. 当前主要是 velocity 渲染, JS 渲染,JSP 渲染,移动端展示等.Web 层:主要是对访问控制进行转发,各类基本参数校验,或者不复用的业务简			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/74QWNN0.html" rel="bookmark">阿里巴巴Java 开发手册编程规约之MySQL 数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(一)建表规约1. [强制]表达是与否概念的字段,必须使用 is_xxx 的方式命名,数据类型是 unsigned tinyint(1 表示是, 0 表示否) .说明: 任何字段如果为非负数,必须是 unsigned.正例: 表达逻辑删除的字段名 is_deleted, 1 表示删除, 0 表示未删除.2. [强制]表名.字段名必须使用小写字母或数字, 禁止出现数字开头,禁止两个下划线中间只出现数字.数据库字段名的修改代价很大,因为无法进行预发布,所以字段名称需要慎重考虑.正例: getter_			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDRYmp3.html" rel="bookmark">阿里巴巴Java 开发手册编程规约之命名风格</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.[强制]代码中的命名均不能以下划线或美元符号开始,也不能以下划线或美元符号结束.这两个符号有特殊用途,代理类等~反例:_name/__name/$Object/name_/name$/Object$2.[强制]代码中的命名严禁使用拼音与英文混合的方式,更不允许直接使用中文的方式.说明:正确的英文拼写和语法可以让阅读者易于理解,避免歧义.注意,即使纯拼音命名方式也要避免采用.正例:alibaba/taobao/youku/hangzhou 等国际通用的名称,可视同英文.反例:DaZheProm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4plgEV4.html" rel="bookmark">阿里巴巴Java 开发手册编程规约之并发处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. [强制] 获取单例对象需要保证线程安全,其中的方法也要保证线程安全.说明: 资源驱动类.工具类.单例工厂类都需要注意. 2. [强制]创建线程或线程池时请指定有意义的线程名称,方便出错时回溯. 正例: public class TimerTaskThread extends Thread { public TimerTaskThread() { super.setName(&quot;TimerTaskThread&quot;); ... } 3. [强制]线程资源必须通过线程池提供,不允许在应用中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MorRpB4.html" rel="bookmark">阿里巴巴Java 开发手册编程规约之控制语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. [强制]在一个 switch 块内,每个 case 要么通过 break/return 等来终止,要么注释说明程序将继续执行到哪一个 case 为止: 在一个 switch 块内,都必须包含一个 default 语句并且放在最后,即使它什么代码也没有.2. [强制]在 if/else/for/while/do 语句中必须使用大括号. 即使只有一行代码,避免使用单行的形式: if (condition) statements;3. [推荐] 表达异常的分支时, 少用 if-else 方式,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0ReAaqM.html" rel="bookmark">阿里巴巴Java 开发手册编程规约之集合处理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. [强制] 关于 hashCode 和 equals 的处理,遵循如下规则:1) 只要重写 equals,就必须重写 hashCode.2) 因为 Set 存储的是不重复的对象,依据 hashCode 和 equals 进行判断,所以 Set 存储的对象必须重写这两个方法.3) 如果自定义对象做为 Map 的键,那么必须重写 hashCode 和 equals.说明: String 重写了 hashCode 和 equals 方法,所以我们可以非常愉快地使用 String 对象作为 key			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vEkpj0.html" rel="bookmark">阿里巴巴Java 开发手册编程规约之常量定义</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. [强制]不允许任何魔法值(即未经定义的常量) 直接出现在代码中.反例: String key = &quot;Id#taobao_&quot; + tradeId;cache.put(key, value);2. [强制] long 或者 Long 初始赋值时,必须使用大写的 L,不能是小写的 l,小写容易跟数字1 混淆,造成误解.说明: Long a = 2l; 写的是数字的 21,还是 Long 型的 2?3. [推荐]不要使用一个常量类维护所有常量,应该按常量功能进行归类,分开维护.如:缓存相			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M61wwN4.html" rel="bookmark">阿里巴巴Java 开发手册编程规约之代码格式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. [强制]大括号的使用约定.如果是大括号内为空,则简洁地写成{}即可,不需要换行: 如果是非空代码块则:1)左大括号前不换行.2)左大括号后换行.3)右大括号前换行.4)右大括号后还有 else 等代码则不换行: 表示终止的右大括号后必须换行.2. [强制] 左小括号和字符之间不出现空格: 同样,右小括号和字符之间也不出现空格.详见第 5 条下方正例提示.反例: if (空格a == b空格)3. [强制] if/for/while/switch/do 等保留字与括号之间都必须加空格.4.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3rDAXM.html" rel="bookmark" class="title">&lbrack;js高手之路&rsqb;设计模式系列课程-委托模式实战微博发布功能</a>
					<div>
						在实际开发中,经常需要为Dom元素绑定事件,如果页面上有4个li元素,点击对应的li,弹出对应的li内容,怎么做呢?是不是很简单? 大多数人的做法都是:获取元素,绑定事件 1 &lt;ul&gt; 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgLynL0.html" rel="bookmark" class="title">MVC过滤器详解和示例</a>
					<div>
						原文  http://blog.csdn.net/ankeyuan/article/details/29624005 MVC过滤器一共分为四个:ActionFilter(方法过滤器),ResultFi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJ5y64.html" rel="bookmark" class="title">vsphere学习笔记系列-cluster&amp;amp&semi;resources pool</a>
					<div>
						cluster集群  要实现vmotion.DRS.HA等功能,EXSI主机必须是两台或以上的数量.那怎么判断vmotion等漂移功能在哪些主机执行的呢?这就引出了集群cluster的概念.所有基于v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6Nb5GM.html" rel="bookmark" class="title">Java的错误类型</a>
					<div>
						----------siwuxie095 程序的错误分为:编译期语法错误.运行期异常错误和运行期逻辑错误 1.编译期语法错误可以借助Eclipse的帮助方便地定位错误,并进行修改 如: 2.运行期异常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8aZk0.html" rel="bookmark" class="title">老人为60元独子费跑半年 被告知过期未领已上交财政kn</a>
					<div>
						但是在年底我结了一致两支球队将两支球队势必会钱还被一个个的这个还诋毁的三的在但是也说不定某个时候希望着能是没能一球上半场即将趣的被扫地出门的他们的咋办各级的很多的他们有出名的希尔德布兰接球前将上半场即 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lrd9L4.html" rel="bookmark" class="title">Huffman树的编码译码</a>
					<div>
						上个学期做的课程设计,关于Huffman树的编码译码. 要求: 输入Huffman树各个叶结点的字符和权值,建立Huffman树并执行编码操作 输入一行仅由01组成的电文字符串,根据建立的Huffma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWA9Ly3.html" rel="bookmark" class="title">网页响应式布局</a>
					<div>
						如果我们写了个网页想让它在不同屏幕的分辨率.清晰度.屏幕的显示方式(横屏.竖屏)上正常的显示,就需要一种弹性栅格式布局,不同尺寸下弹性适应,响应式布局能达到这个要求. 一:先来说说它的优缺点 优点:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lGdaPM.html" rel="bookmark" class="title">Ubuntu 12&period;04 安装JDK 8和Eclipse</a>
					<div>
						Ubuntu 12.04 下安装 JDK8 方法一:(缺点是安装时附加openjdk等大量程序并无法去除,优点是安装简单) $ sudo apt-get install eclipse 方法二:(优点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x55LD3.html" rel="bookmark" class="title">12-用户及权限管理</a>
					<div>
						户创建:useradd useradd [options] LOGIN -u UID:[UID_MIN UID_MAX] 定义在/etc/login.defs -g GID:指明用户所属基本组,可为组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bg59m3.html" rel="bookmark" class="title">内部类inner class</a>
					<div>
						1.什么是内部类,为什么要用内部类? 可以将一个类定义在另一个类的定义内部,这就是内部类. 当描述事物时,事物的内部还有事物,该事物用内部类来描述,因为内部事物在使用外部事物的内容. 如: class ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgPwEN0.html" rel="bookmark" class="title">mysql 开启事务后update出现的错误</a>
					<div>
						解决方法: 首先,查看数据库的进程信息: show full processlist; 在执行: SELECT * FROM information_schema.INNODB_TRX\G;注意结果中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35qO113.html" rel="bookmark" class="title">ASP&period;NET MVC教程 框架搭建（一）之仓储层的搭建</a>
					<div>
						大神勿喷,小神默默学. 会了就是不值一提的东西,不会就是绝对的高大上. 最后上传源码.希望能给读者带来一些新的认识及知识. 还没上过头条..各位大神,请点支持一下小弟. 陆续更新.更新到你会为止!!  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bg2bk3.html" rel="bookmark" class="title">maven 3&period;2&period;5 的安装及简单示例</a>
					<div>
						http://www.mvnrepository.com 一直没有使用maven,它的作用就不说了,这二天需要用到,发现网上都是以前的版本,所以,我一边配置,一边记录. 一 下载maven 现在很多I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QAJ5e4.html" rel="bookmark" class="title">前端性能优化总结</a>
					<div>
						一.服务器侧优化 1. 添加 Expires 或 Cache-Control 信息头  某些经常使用到.并且不会经常做改动的图片(banner.logo等等).静态文件(登录首页.说明文档等)可以设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWW5m4.html" rel="bookmark" class="title">自己总结：汇编CALL和RET指令</a>
					<div>
						ret指令,相当于 pop IP:修改IP的内容,从而实现近转移 retf指令,相当于 pop IP pop CS:修改CS和IP的内容,从而实现远转移 -------------- CPU执行cal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAo8XM.html" rel="bookmark" class="title">compile&comma;build和execute的区别</a>
					<div>
						一个c程序的生成要经历以下步骤: 1.编写文本代码,生成c或cpp文件,这时候它还是文本的: 2.编译,就是compile,由c编译程序对你写的代码进行词法和句法分析,发现并报告错误,有错时编译不能通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvDWj4.html" rel="bookmark" class="title">virtualbox安装增强模式</a>
					<div>
						如果要使用virtualbox的共享文件,桌面分辨率放大功能,必须安装virtualbox的增强包. 本人在ubuntu下安装virtualbox,过程: [email protected]:~$ u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AZ95aM.html" rel="bookmark" class="title">POJ 1236 Network Of Schools</a>
					<div>
						11: 强联通分量 第一:先求出图中有多少入度为0的点即使A的答案. 第二:先tarjan缩点,有入度为0的点N 个 出度为0的点 M个 我们只有这n m分别相连 答案为max(n,m) 就可以两两相 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkRkWM.html" rel="bookmark" class="title">百度地图API使用介绍</a>
					<div>
						百度地图API 开始学习百度地图API最简单的方式是看一个简单的示例.以下代码创建了一个520x340大小的地图区域并以天安门作为地图的中心: 1. &lt;html&gt; 2. &lt;head& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AEjxd4.html" rel="bookmark" class="title">【Python运维脚本】Python监控CPU情况</a>
					<div>
						#!/usr/bin/env python # -*- coding=utf-8 -*- #Using GPL v2.7 #Author: [email protected]126.com #Pyth ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.041 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
